Index: uspace/lib/gui/Makefile
===================================================================
--- uspace/lib/gui/Makefile	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
+++ uspace/lib/gui/Makefile	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -0,0 +1,45 @@
+#
+# Copyright (c) 2012 Petr Koupy
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+USPACE_PREFIX = ../..
+LIBRARY = libgui
+SLIBRARY = libgui.so.0.0
+LSONAME = libgui.so0
+EXTRA_CFLAGS += -I$(LIBDRAW_PREFIX) -I$(LIBSOFTREND_PREFIX) -I$(LIBGRAPH_PREFIX)
+
+SOURCES = \
+	button.c \
+	connection.c \
+	grid.c \
+	label.c \
+	minimal.c \
+	terminal.c \
+	widget.c \
+	window.c
+
+include $(USPACE_PREFIX)/Makefile.common
Index: uspace/lib/gui/button.c
===================================================================
--- uspace/lib/gui/button.c	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
+++ uspace/lib/gui/button.c	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -0,0 +1,189 @@
+/*
+ * Copyright (c) 2012 Petr Koupy
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup gui
+ * @{
+ */
+/**
+ * @file
+ */
+
+#include <str.h>
+#include <malloc.h>
+
+#include <drawctx.h>
+#include <surface.h>
+
+#include "window.h"
+#include "button.h"
+
+static void paint_internal(widget_t *w)
+{
+	button_t *btn = (button_t *) w;
+
+	surface_t *surface = window_claim(btn->widget.window);
+	if (!surface) {
+		window_yield(btn->widget.window);
+	}
+
+	drawctx_t drawctx;
+
+	drawctx_init(&drawctx, surface);
+	drawctx_set_source(&drawctx, &btn->foreground);
+	drawctx_transfer(&drawctx, w->hpos, w->vpos, w->width, w->height);
+
+	if (w->width >= 6 && w->height >= 6) {
+		drawctx_set_source(&drawctx, &btn->background);
+		drawctx_transfer(&drawctx,
+		    w->hpos + 3, w->vpos + 3, w->width - 6, w->height - 6);
+	}
+
+	sysarg_t cpt_width;
+	sysarg_t cpt_height;
+	font_get_box(&btn->font, btn->caption, &cpt_width, &cpt_height);
+	if (w->width >= cpt_width && w->height >= cpt_height) {
+		drawctx_set_source(&drawctx, &btn->foreground);
+		drawctx_set_font(&drawctx, &btn->font);
+		sysarg_t x = ((w->width - cpt_width) / 2) + w->hpos;
+		sysarg_t y = ((w->height - cpt_height) / 2) + w->vpos;
+		if (btn->caption) {
+			drawctx_print(&drawctx, btn->caption, x, y);
+		}
+	}
+
+	window_yield(btn->widget.window);
+}
+
+void deinit_button(button_t *btn)
+{
+	widget_deinit(&btn->widget);
+	free(btn->caption);
+	font_release(&btn->font);
+}
+
+static void button_destroy(widget_t *widget)
+{
+	button_t *btn = (button_t *) widget;
+
+	deinit_button(btn);
+	
+	free(btn);
+}
+
+static void button_reconfigure(widget_t *widget)
+{
+	/* no-op */
+}
+
+static void button_rearrange(widget_t *widget, sysarg_t hpos, sysarg_t vpos,
+    sysarg_t width, sysarg_t height)
+{
+	widget_modify(widget, hpos, vpos, width, height);
+	paint_internal(widget);
+}
+
+static void button_repaint(widget_t *widget)
+{
+	paint_internal(widget);
+	window_damage(widget->window);
+}
+
+static void button_handle_keyboard_event(widget_t *widget, kbd_event_t event)
+{
+	button_t *btn = (button_t *) widget;
+	if (event.key == KC_ENTER && event.type == KEY_PRESS) {
+		sig_send(&btn->clicked, NULL);
+	}
+}
+
+static void button_handle_position_event(widget_t *widget, pos_event_t event)
+{
+	button_t *btn = (button_t *) widget;
+	widget->window->focus = widget;
+
+	// TODO make the click logic more robust (mouse grabbing, mouse moves)
+	if (event.btn_num == 1) {
+		if (event.type == POS_RELEASE) {
+			sig_send(&btn->clicked, NULL);
+		}
+	}
+}
+
+bool init_button(button_t *btn, widget_t *parent,
+    const char *caption, uint16_t points, pixel_t background, pixel_t foreground)
+{
+	widget_init(&btn->widget, parent);
+
+	btn->widget.destroy = button_destroy;
+	btn->widget.reconfigure = button_reconfigure;
+	btn->widget.rearrange = button_rearrange;
+	btn->widget.repaint = button_repaint;
+	btn->widget.handle_keyboard_event = button_handle_keyboard_event;
+	btn->widget.handle_position_event = button_handle_position_event;
+
+	source_init(&btn->background);
+	source_set_color(&btn->background, background);
+	source_init(&btn->foreground);
+	source_set_color(&btn->foreground, foreground);
+
+	if (caption == NULL) {
+		btn->caption = NULL;
+	} else {
+		btn->caption = str_dup(caption);
+	}
+	font_init(&btn->font, FONT_DECODER_EMBEDDED, NULL, points);
+
+	sysarg_t cpt_width;
+	sysarg_t cpt_height;
+	font_get_box(&btn->font, btn->caption, &cpt_width, &cpt_height);
+	btn->widget.width_min = cpt_width + 8;
+	btn->widget.height_min = cpt_height + 8;
+	btn->widget.width_ideal = cpt_width + 28;
+	btn->widget.height_ideal = cpt_height + 8;
+
+	return true;
+}
+
+button_t *create_button(widget_t *parent,
+    const char *caption, uint16_t points, pixel_t background, pixel_t foreground)
+{
+	button_t *btn = (button_t *) malloc(sizeof(button_t));
+	if (!btn) {
+		return NULL;
+	}
+
+	if (init_button(btn, parent, caption, points, background, foreground)) {
+		return btn;
+	} else {
+		free(btn);
+		return NULL;
+	}
+}
+
+/** @}
+ */
Index: uspace/lib/gui/button.h
===================================================================
--- uspace/lib/gui/button.h	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
+++ uspace/lib/gui/button.h	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -0,0 +1,64 @@
+/*
+ * Copyright (c) 2012 Petr Koupy
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup gui
+ * @{
+ */
+/**
+ * @file
+ */
+
+#ifndef GUI_BUTTON_H_
+#define GUI_BUTTON_H_
+
+#include <sys/types.h>
+#include <io/pixel.h>
+
+#include <source.h>
+#include <font.h>
+
+#include "connection.h"
+#include "widget.h"
+
+typedef struct button {
+	widget_t widget;
+	source_t background;
+	source_t foreground;
+	char *caption;
+	font_t font;
+	signal_t clicked;
+} button_t;
+
+extern bool init_button(button_t *, widget_t *, const char *, uint16_t, pixel_t, pixel_t);
+extern button_t *create_button(widget_t *, const char *, uint16_t, pixel_t, pixel_t);
+extern void deinit_button(button_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/gui/connection.c
===================================================================
--- uspace/lib/gui/connection.c	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
+++ uspace/lib/gui/connection.c	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -0,0 +1,236 @@
+/*
+ * Copyright (c) 2012 Petr Koupy
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup gui
+ * @{
+ */
+/**
+ * @file
+ */
+
+#include <mem.h>
+#include <malloc.h>
+#include <adt/list.h>
+#include <adt/prodcons.h>
+#include <fibril_synch.h>
+#include <io/window.h>
+
+#include "window.h"
+#include "widget.h"
+#include "connection.h"
+
+typedef struct {
+	link_t link;
+	widget_t *widget;
+	slot_t slot;
+} slot_node_t;
+
+typedef struct {
+	link_t link;
+	signal_t *signal;
+	list_t slots;
+} signal_node_t;
+
+static FIBRIL_RWLOCK_INITIALIZE(connection_guard);
+static LIST_INITIALIZE(connection_list);
+
+void sig_connect(signal_t *signal, widget_t *widget, slot_t slot)
+{
+	fibril_rwlock_write_lock(&connection_guard);
+
+	signal_node_t *sig_node = NULL;
+	list_foreach(connection_list, link) {
+		signal_node_t *cur = list_get_instance(link, signal_node_t, link);
+		if (cur->signal == signal) {
+			sig_node = cur;
+			break;
+		}
+	}
+
+	if (!sig_node) {
+		sig_node = (signal_node_t *) malloc(sizeof(signal_node_t));
+		if (!sig_node) {
+			fibril_rwlock_write_unlock(&connection_guard);
+			return;
+		}
+
+		sig_node->signal = signal;
+		link_initialize(&sig_node->link);
+		list_initialize(&sig_node->slots);
+
+		list_append(&sig_node->link, &connection_list);
+	}
+
+	slot_node_t *slt_node = NULL;
+	list_foreach(sig_node->slots, link) {
+		slot_node_t *cur = list_get_instance(link, slot_node_t, link);
+		if (cur->widget == widget && cur->slot == slot) {
+			slt_node = cur;
+			fibril_rwlock_write_unlock(&connection_guard);
+			break;
+		}
+	}
+
+	if (!slt_node) {
+		slt_node = (slot_node_t *) malloc(sizeof(slot_node_t));
+		if (!slt_node) {
+			fibril_rwlock_write_unlock(&connection_guard);
+			return;
+		}
+
+		slt_node->widget = widget;
+		slt_node->slot = slot;
+		link_initialize(&slt_node->link);
+
+		list_append(&slt_node->link, &sig_node->slots);
+	} else {
+		/* Already connected. */
+	}
+
+	fibril_rwlock_write_unlock(&connection_guard);
+}
+
+void sig_disconnect(signal_t *signal, widget_t *widget, slot_t slot)
+{
+	fibril_rwlock_write_lock(&connection_guard);
+
+	signal_node_t *sig_node = NULL;
+	list_foreach(connection_list, link) {
+		signal_node_t *cur = list_get_instance(link, signal_node_t, link);
+		if (cur->signal == signal) {
+			sig_node = cur;
+			break;
+		}
+	}
+
+	if (!sig_node) {
+		fibril_rwlock_write_unlock(&connection_guard);
+		return;
+	}
+
+	slot_node_t *slt_node = NULL;
+	list_foreach(sig_node->slots, link) {
+		slot_node_t *cur = list_get_instance(link, slot_node_t, link);
+		if (cur->widget == widget && cur->slot == slot) {
+			slt_node = cur;
+			break;
+		}
+	}
+
+	if (!slt_node) {
+		fibril_rwlock_write_unlock(&connection_guard);
+		return;
+	}
+
+	list_remove(&slt_node->link);
+	free(slt_node);
+
+	if (list_empty(&sig_node->slots)) {
+		list_remove(&sig_node->link);
+		free(sig_node);
+	}
+
+	fibril_rwlock_write_unlock(&connection_guard);
+}
+
+void sig_send(signal_t *signal, void *data)
+{
+	fibril_rwlock_read_lock(&connection_guard);
+
+	signal_node_t *sig_node = NULL;
+	list_foreach(connection_list, link) {
+		signal_node_t *cur = list_get_instance(link, signal_node_t, link);
+		if (cur->signal == signal) {
+			sig_node = cur;
+			break;
+		}
+	}
+
+	if (!sig_node) {
+		fibril_rwlock_read_unlock(&connection_guard);
+		return;
+	}
+
+	list_foreach(sig_node->slots, link) {
+		slot_node_t *cur = list_get_instance(link, slot_node_t, link);
+		cur->slot(cur->widget, data);
+	}
+
+	fibril_rwlock_read_unlock(&connection_guard);
+}
+
+void sig_post(signal_t *signal, void *data, size_t data_size)
+{
+	fibril_rwlock_read_lock(&connection_guard);
+
+	signal_node_t *sig_node = NULL;
+	list_foreach(connection_list, link) {
+		signal_node_t *cur = list_get_instance(link, signal_node_t, link);
+		if (cur->signal == signal) {
+			sig_node = cur;
+			break;
+		}
+	}
+
+	if (!sig_node) {
+		fibril_rwlock_read_unlock(&connection_guard);
+		return;
+	}
+
+	list_foreach(sig_node->slots, link) {
+		slot_node_t *cur = list_get_instance(link, slot_node_t, link);
+
+		void *data_copy = NULL;
+		if (data != NULL) {
+			data_copy = malloc(data_size);
+		}
+		if (data_copy != NULL) {
+			memcpy(data_copy, data, data_size);
+		}
+		window_event_t *event =
+			(window_event_t *) malloc(sizeof(window_event_t));
+
+		if (event) {
+			link_initialize(&event->link);
+			event->type = ET_SIGNAL_EVENT;
+			event->data.sig.object = (sysarg_t) cur->widget;
+			event->data.sig.slot = (sysarg_t) cur->slot;
+			event->data.sig.argument = (sysarg_t) data_copy;
+			prodcons_produce(&cur->widget->window->events, &event->link);
+		} else {
+			if (data_copy != NULL) {
+				free(data_copy);
+			}
+		}
+	}
+
+	fibril_rwlock_read_unlock(&connection_guard);
+}
+
+/** @}
+ */
Index: uspace/lib/gui/connection.h
===================================================================
--- uspace/lib/gui/connection.h	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
+++ uspace/lib/gui/connection.h	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -0,0 +1,56 @@
+/*
+ * Copyright (c) 2012 Petr Koupy
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup gui
+ * @{
+ */
+/**
+ * @file
+ */
+
+#ifndef GUI_CONNECTION_H_
+#define GUI_CONNECTION_H_
+
+#include <sys/types.h>
+
+struct widget;
+typedef struct widget widget_t;
+
+typedef sysarg_t signal_t;
+typedef void (*slot_t)(widget_t *, void *);
+
+extern void sig_connect(signal_t *, widget_t *, slot_t);
+extern void sig_disconnect(signal_t *, widget_t *, slot_t);
+
+extern void sig_send(signal_t *, void *);
+extern void sig_post(signal_t *, void *, size_t);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/gui/grid.c
===================================================================
--- uspace/lib/gui/grid.c	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
+++ uspace/lib/gui/grid.c	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -0,0 +1,255 @@
+/*
+ * Copyright (c) 2012 Petr Koupy
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup gui
+ * @{
+ */
+/**
+ * @file
+ */
+
+#include <assert.h>
+#include <mem.h>
+#include <malloc.h>
+#include <surface.h>
+
+#include "window.h"
+#include "grid.h"
+
+static void paint_internal(widget_t *w)
+{
+	grid_t *grid = (grid_t *) w;
+
+	surface_t *surface = window_claim(grid->widget.window);
+	if (!surface) {
+		window_yield(grid->widget.window);
+	}
+
+	for (sysarg_t y = w->vpos; y <  w->vpos + w->height; ++y) {
+		for (sysarg_t x = w->hpos; x < w->hpos + w->width; ++x) {
+			surface_put_pixel(surface, x, y, grid->background);
+		}
+	}
+
+	window_yield(grid->widget.window);
+}
+
+static widget_t **widget_at(grid_t *grid, size_t row, size_t col)
+{
+	if (row < grid->rows && col < grid->cols) {
+		return grid->layout + (row * grid->cols + col);
+	} else {
+		return NULL;
+	}
+}
+
+void deinit_grid(grid_t *grid)
+{
+	widget_deinit(&grid->widget);
+	free(grid->layout);
+}
+
+static void grid_destroy(widget_t *widget)
+{
+	grid_t *grid = (grid_t *) widget;
+
+	deinit_grid(grid);
+
+	free(grid);
+}
+
+static void grid_reconfigure(widget_t *widget)
+{
+	/* no-op */
+}
+
+static void grid_rearrange(widget_t *widget, sysarg_t hpos, sysarg_t vpos,
+    sysarg_t width, sysarg_t height)
+{
+	grid_t *grid = (grid_t *) widget;
+
+	widget_modify(widget, hpos, vpos, width, height);
+	paint_internal(widget);
+
+	sysarg_t cell_width = width / grid->cols;
+	sysarg_t cell_height = height / grid->rows;
+
+	list_foreach(widget->children, link) {
+		widget_t *child = list_get_instance(link, widget_t, link);
+
+		sysarg_t widget_hpos = 0;
+		sysarg_t widget_vpos = 0;
+		sysarg_t widget_width = 0;
+		sysarg_t widget_height = 0;
+
+		size_t r = 0;
+		size_t c = 0;
+		for (r = 0; r < grid->rows; ++r) {
+			bool found = false;
+			for (c = 0; c < grid->cols; ++c) {
+				widget_t **cell = widget_at(grid, r, c);
+				if (cell && *cell == child) {
+					found = true;
+					break;
+				}
+			}
+			if (found) {
+				break;
+			}
+		}
+
+		widget_hpos = cell_width * c + hpos;
+		widget_vpos = cell_height * r + vpos;
+
+		for (size_t _c = c; _c < grid->cols; ++_c) {
+			widget_t **cell = widget_at(grid, r, _c);
+			if (cell && *cell == child) {
+				widget_width += cell_width;
+			} else {
+				break;
+			}
+		}
+
+		for (size_t _r = r; _r < grid->rows; ++_r) {
+			widget_t **cell = widget_at(grid, _r, c);
+			if (cell && *cell == child) {
+				widget_height += cell_height;
+			} else {
+				break;
+			}
+		}
+
+		if (widget_width > 0 && widget_height > 0) {
+			child->rearrange(child,
+			    widget_hpos, widget_vpos, widget_width, widget_height);
+		}
+	}
+}
+
+static void grid_repaint(widget_t *widget)
+{
+	paint_internal(widget);
+	list_foreach(widget->children, link) {
+		widget_t *child = list_get_instance(link, widget_t, link);
+		child->repaint(child);
+	}
+	window_damage(widget->window);
+}
+
+static void grid_handle_keyboard_event(widget_t *widget, kbd_event_t event)
+{
+	/* no-op */
+}
+
+static void grid_handle_position_event(widget_t *widget, pos_event_t event)
+{
+	grid_t *grid = (grid_t *) widget;
+
+	if ((widget->height / grid->rows) == 0) {
+		return;
+	}
+	if ((widget->width / grid->cols) == 0) {
+		return;
+	}
+
+	sysarg_t row = (event.vpos - widget->vpos) / (widget->height / grid->rows);
+	sysarg_t col = (event.hpos - widget->hpos) / (widget->width / grid->cols);
+
+	widget_t **cell = widget_at(grid, row, col);
+	if (cell && *cell) {
+		(*cell)->handle_position_event(*cell, event);
+	}
+}
+
+static void grid_add(grid_t *grid, widget_t *widget,
+    size_t row, size_t col, size_t rows, size_t cols)
+{
+	assert(row + rows <= grid->rows);
+	assert(col + cols <= grid->cols);
+
+	widget->parent = (widget_t *) grid;
+	list_append(&widget->link, &grid->widget.children);
+	widget->window = grid->widget.window;
+
+	for (size_t r = row; r < row + rows; ++r) {
+		for (size_t c = col; c < col + cols; ++c) {
+			widget_t **cell = widget_at(grid, r, c);
+			if (cell) {
+				*cell = widget;
+			}
+		}
+	}
+}
+
+bool init_grid(grid_t *grid,
+    widget_t *parent, size_t rows, size_t cols, pixel_t background)
+{
+	assert(rows > 0);
+	assert(cols > 0);
+
+	widget_t **layout = (widget_t **) malloc(rows * cols * sizeof(widget_t *));
+	if (!layout) {
+		return false;
+	}
+	memset(layout, 0, rows * cols * sizeof(widget_t *));
+
+	widget_init(&grid->widget, parent);
+
+	grid->widget.destroy = grid_destroy;
+	grid->widget.reconfigure = grid_reconfigure;
+	grid->widget.rearrange = grid_rearrange;
+	grid->widget.repaint = grid_repaint;
+	grid->widget.handle_keyboard_event = grid_handle_keyboard_event;
+	grid->widget.handle_position_event = grid_handle_position_event;
+
+	grid->add = grid_add;
+	grid->background = background;
+	grid->rows = rows;
+	grid->cols = cols;
+	grid->layout = layout;
+
+	return true;
+}
+
+grid_t *create_grid(widget_t *parent, size_t rows, size_t cols, pixel_t background)
+{
+	grid_t *grid = (grid_t *) malloc(sizeof(grid_t));
+	if (!grid) {
+		return NULL;
+	}
+
+	if (init_grid(grid, parent, rows, cols, background)) {
+		return grid;
+	} else {
+		free(grid);
+		return NULL;
+	}
+}
+
+/** @}
+ */
Index: uspace/lib/gui/grid.h
===================================================================
--- uspace/lib/gui/grid.h	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
+++ uspace/lib/gui/grid.h	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -0,0 +1,63 @@
+/*
+ * Copyright (c) 2012 Petr Koupy
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup gui
+ * @{
+ */
+/**
+ * @file
+ */
+
+#ifndef GUI_GRID_H_
+#define GUI_GRID_H_
+
+#include <sys/types.h>
+#include <io/pixel.h>
+
+#include "widget.h"
+
+struct grid;
+typedef struct grid grid_t;
+
+typedef struct grid {
+	widget_t widget;
+	pixel_t background;
+	size_t rows;
+	size_t cols;
+	widget_t **layout;
+	void (*add)(grid_t *, widget_t *, size_t, size_t, size_t, size_t);
+} grid_t;
+
+extern bool init_grid(grid_t *, widget_t *, size_t, size_t, pixel_t);
+extern grid_t *create_grid(widget_t *, size_t, size_t, pixel_t);
+extern void deinit_grid(grid_t *);
+
+#endif
+
+/** @}
+ */
